/*
  Programme écrit par Silicium628
  ce logiciel est libre et open source

  */
#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <stdlib.h>


// #include <QDebug>

QString version = "3.2";

int L1_max,C1_max;
int L2_max,C2_max;
int L3_max,C3_max;


//float M1[5][5];
//float M2[5][5];
//float M3[5][5];

//float M4[2][2]; // matrice 2x2 à inverser
//float M5[2][2]; // matrice 2x2 inverse



MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent)
{

    setupUi(this);
 //   this->setFixedSize(1240, 960);
    setWindowTitle("Calcul matriciel v:" + version);

    init_coeffs();
    init_LC();

    init_TW_i(tableWidget_M1, &M1);
    init_TW_i(tableWidget_M2, &M2);
    init_TW_i(tableWidget_M3, &M3);
    init_TW_i(tableWidget_M4, &M4);
    init_TW_i(tableWidget_M5, &M5);

    affi_Mi_to_TWi(&M1, tableWidget_M1);
    affi_Mi_to_TWi(&M2, tableWidget_M2);
    affi_Mi_to_TWi(&M3, tableWidget_M3);
}



MainWindow::~MainWindow()
{

}


void MainWindow::init_coeffs()  // au départ
{

    M1.L_max=2;
    M1.C_max=3;
    M1.coeff[0][0]=0.3;     M1.coeff[0][1]=2.0;     M1.coeff[0][2]=3.0;
    M1.coeff[1][0]=0.0;     M1.coeff[1][1]=-1.0;    M1.coeff[1][2]=2.0;

    M2.L_max=3;
    M2.C_max=2;
    M2.coeff[0][0]=1.1;     M2.coeff[0][1]=4.5;
    M2.coeff[1][0]=2.0;     M2.coeff[1][1]=0.0;
    M2.coeff[2][0]=-1.0;    M2.coeff[2][1]=3.0;

    M3.L_max=2;
    M3.C_max=2;


    M4.L_max=2;
    M4.C_max=2;
    M4.coeff[0][0]=0;       M4.coeff[0][1]=0;
    M4.coeff[1][0]=0;       M4.coeff[1][1]=0;

    M5.L_max=2;
    M5.C_max=2;
}





void MainWindow::init_LC()
{
    QString tx1,tx2,tx3,tx4;

    L1_max=spinBox_M1_L->value(); tx1.setNum(L1_max);
    M1.L_max=L1_max;
    C1_max=spinBox_M1_C->value(); tx2.setNum(C1_max);
    M1.C_max=C1_max;

    L2_max=C1_max; tx3.setNum(L2_max); // pour que le produit matriciel soit défini
    M2.L_max=L2_max;

    lineEdit_M2_L->setText(tx3);
    C2_max=spinBox_M2_C->value(); tx4.setNum(C2_max);
    M2.C_max=C2_max;

    L3_max=L1_max;
    M3.L_max=L3_max;
    C3_max=C2_max;
    M3.C_max=C3_max;

    label_M1->setText("("+tx1+"x"+tx2+")");
    label_M2->setText("("+tx3+"x"+tx4+")");


}


void MainWindow::init_TW_i(QTableWidget *table_i, Matrice *Mi)
{

    QString tx;
    int L, C, i, L_max, C_max;

    L_max=Mi->L_max;
    C_max=Mi->C_max;

    table_i->setRowCount(L_max);
    table_i->setColumnCount(C_max);

    i=0;
    for(L=0; L < L_max; L++)
    {
        for(C=0; C < C_max; C++)
        {
            i++;
            //tx.setNum(i);
            table_i->setItem(L, C,new QTableWidgetItem ("0"));
        }
    }
}


void MainWindow::MAJ_Mi(QTableWidget *table_i, Matrice *Mi)
{
//copie les valeurs affichée -> vers une matrice
    QString tx;
    int L,C, L_max, C_max;
    float valeur;
    L_max=Mi->L_max;
    C_max=Mi->C_max;

    for(L=0; L < L_max; L++)
    {
        for(C=0; C < C_max; C++)
        {
            tx=table_i->item(L,C)->text();
            valeur =tx.toFloat();
            Mi->coeff[L][C]=valeur;
        }
    }

}


void MainWindow::affi_Mi_to_TWi(Matrice *Mi, QTableWidget *table_i)
{
//affiche les valeurs d'une matrice
    int L, C, L_max, C_max;
    QString tx;
    float valeur;

    L_max=Mi->L_max;
    C_max=Mi->C_max;

    for(L=0; L < L_max; L++)
     {
        for(C=0; C < C_max; C++)
        {
            valeur = Mi->coeff[L][C];
            tx= QString::number(valeur, 'f', 2);
            table_i->item(L,C)->setText(tx);
        }
    }
    table_i->resizeColumnsToContents();
}




void MainWindow::affi_delta(float valeur)
{
    QString tx;
    tx= QString::number(valeur, 'f', 4);
    lineEdit_1->setText(tx);

}


void MainWindow::calcul_produit_matriciel()
{
    int L1,C1,L2,C2,L3,C3;
    float facteur1, facteur2, partiel, cumul;
    QString tx,tx1;


    MAJ_Mi(tableWidget_M1, &M1);
    MAJ_Mi(tableWidget_M2, &M2);
    tx1="[ ";
    for(L3=0; L3<L3_max; L3++)
    {
        L1=L3;
        for(C3=0; C3<C3_max; C3++)
        {
            C2=C3;
            M3.coeff[L3][C3]=0;
            tx="   ";

            cumul=0;
            for(C1=0; C1<C1_max; C1++)
            {
                L2=C1;
                facteur1=M1.coeff[L1][C1];
                facteur2=M2.coeff[L2][C2];
                partiel = facteur1*facteur2;
                cumul+= partiel;
                M3.coeff[L3][C3]= cumul; // on cumule les produits partiels ici

                //ce qui suit ne sert qu'à afficher le détail des opérations dans un but pédagogique
                tx= QString::number(M1.coeff[L1][C1], 'f', 2); tx1+=tx+"*";
                tx= QString::number(M2.coeff[L2][C2], 'f', 2);  tx1+=tx+"=";
                tx= QString::number(partiel, 'f', 2);  tx1+=tx+" ]   [ "; //+"\n";
                textEdit1->setText(tx1+"\n"+"---");
            }
            tx= QString::number(cumul, 'f', 2);  tx1+="Total: "+tx+" ]\n[ ";
            textEdit1->setText(tx1+"\n");
        }
    }
}


void MainWindow::Calcul_matrice_inverse()
{
// de M4 vers M5
    float delta, inv_delta;
    MAJ_Mi(tableWidget_M4, &M4);
    delta = M4.coeff[0][0]*M4.coeff[1][1]-M4.coeff[0][1]*M4.coeff[1][0];
    affi_delta(delta);

    if(delta !=0)
    {
        inv_delta=1/delta;
        M5.coeff[0][0]= inv_delta*M4.coeff[1][1];
        M5.coeff[0][1]=-inv_delta*M4.coeff[0][1];
        M5.coeff[1][0]=-inv_delta*M4.coeff[1][0];
        M5.coeff[1][1]= inv_delta*M4.coeff[0][0];
    }
}



void MainWindow::on_pushButton_clicked()
{
    calcul_produit_matriciel();
    affi_Mi_to_TWi(&M3, tableWidget_M3);
}


void MainWindow::on_tableWidget_M1_cellPressed(int row, int column)
{
    QString tx1, tx2,tx3;
    int valeur;
  //  lineEdit1->clear();
  //  tx1.setNum(row);
  //  tx2.setNum(column);
  //  lineEdit1->setText(tx1+"-"+tx2);

    tx3=tableWidget_M1->item(row, column)->text();
    valeur =tx3.toInt();
    M1.coeff[row][column]=valeur;

  //  lineEdit1->setText(tx1+";"+tx2+" -> "+tx3);
}



void MainWindow::on_pushButton_2_clicked()
{
    init_LC();

    init_TW_i(tableWidget_M1, &M1);
    init_TW_i(tableWidget_M2, &M2);
    init_TW_i(tableWidget_M3, &M3);
}





void MainWindow::on_tableWidget_M1_cellChanged(int row, int column)
{


}



void MainWindow::on_tableWidget_M2_cellChanged(int row, int column)
{

}


void MainWindow::on_pushButton_3_clicked()
{
    Calcul_matrice_inverse();
    affi_Mi_to_TWi(&M5, tableWidget_M5);

}

void MainWindow::on_tableWidget_M4_cellChanged(int row, int column)
{
   tableWidget_M4->resizeColumnsToContents();
}
